ICU 74.2: icu::UnicodeStringAppendable Class Reference

ICU 74.2 74.2

Public Member Functions
icu::UnicodeStringAppendable Class Reference

An Appendable implementation which writes to a UnicodeString. More...

`#include <appendable.h>`

Inheritance diagram for icu::UnicodeStringAppendable:

## Public Member Functions
| UnicodeStringAppendable (UnicodeString &s)
| Aliases the UnicodeString (keeps its reference) for writing.
| ~UnicodeStringAppendable ()
| Destructor.
virtual UBool | appendCodeUnit (char16_t c) override
| Appends a 16-bit code unit to the string.
virtual UBool | appendCodePoint (UChar32 c) override
| Appends a code point to the string.
virtual UBool | appendString (const char16_t *s, int32_t length) override
| Appends a string to the UnicodeString.
virtual UBool | reserveAppendCapacity (int32_t appendCapacity) override
| Tells the UnicodeString that the caller is going to append roughly appendCapacity char16_ts.
virtual char16_t * | getAppendBuffer (int32_t minCapacity, int32_t desiredCapacityHint, char16_t *scratch, int32_t scratchCapacity, int32_t *resultCapacity) override
| Returns a writable buffer for appending and writes the buffer's capacity to *resultCapacity.
Public Member Functions inherited from icu::Appendable
| ~Appendable ()
| Destructor.
virtual UBool | appendCodeUnit (char16_t c)=0
| Appends a 16-bit code unit.
virtual UBool | appendCodePoint (UChar32 c)
| Appends a code point.
virtual UBool | appendString (const char16_t *s, int32_t length)
| Appends a string.
virtual UBool | reserveAppendCapacity (int32_t appendCapacity)
| Tells the object that the caller is going to append roughly appendCapacity char16_ts.
virtual char16_t * | getAppendBuffer (int32_t minCapacity, int32_t desiredCapacityHint, char16_t *scratch, int32_t scratchCapacity, int32_t *resultCapacity)
| Returns a writable buffer for appending and writes the buffer's capacity to *resultCapacity.
Public Member Functions inherited from icu::UObject
virtual | ~UObject ()
| Destructor.
virtual UClassID | getDynamicClassID () const
| ICU4C "poor man's RTTI", returns a UClassID for the actual ICU class.

## Detailed Description

An Appendable implementation which writes to a UnicodeString.

This class is not intended for public subclassing.

Stable:
  ICU 4.8

Definition at line 156 of file appendable.h.

## Constructor & Destructor Documentation

## ◆ UnicodeStringAppendable()

icu::UnicodeStringAppendable::UnicodeStringAppendable | ( | UnicodeString & | s | ) |
| inlineexplicit

Aliases the UnicodeString (keeps its reference) for writing.

Parameters

  s | The UnicodeString to which this Appendable will write.

Stable:
  ICU 4.8

Definition at line 163 of file appendable.h.

## ◆ ~UnicodeStringAppendable()

icu::UnicodeStringAppendable::~UnicodeStringAppendable | ( |  | ) |

Destructor.

Stable:
  ICU 4.8

## Member Function Documentation

## ◆ appendCodePoint()

virtual UBool icu::UnicodeStringAppendable::appendCodePoint | ( | UChar32 | c | ) |
| overridevirtual

Appends a code point to the string.

Parameters

  c | code point 0..0x10ffff

Returns
  true if the operation succeeded

Stable:
  ICU 4.8

Reimplemented from icu::Appendable.

## ◆ appendCodeUnit()

virtual UBool icu::UnicodeStringAppendable::appendCodeUnit | ( | char16_t | c | ) |
| overridevirtual

Appends a 16-bit code unit to the string.

Parameters

  c | code unit

Returns
  true if the operation succeeded

Stable:
  ICU 4.8

Implements icu::Appendable.

## ◆ appendString()

virtual UBool icu::UnicodeStringAppendable::appendString | ( | const char16_t * | s,
|  | int32_t | length
| ) |  |
| overridevirtual

Appends a string to the UnicodeString.

Parameters

  s | string, must not be nullptr if length!=0
  length | string length, or -1 if NUL-terminated

Returns
  true if the operation succeeded

Stable:
  ICU 4.8

Reimplemented from icu::Appendable.

## ◆ getAppendBuffer()

virtual char16_t * icu::UnicodeStringAppendable::getAppendBuffer | ( | int32_t | minCapacity,
|  | int32_t | desiredCapacityHint,
|  | char16_t * | scratch,
|  | int32_t | scratchCapacity,
|  | int32_t * | resultCapacity
| ) |  |
| overridevirtual

Returns a writable buffer for appending and writes the buffer's capacity to *resultCapacity.

Guarantees *resultCapacity>=minCapacity. May return a pointer to the caller-owned scratch buffer which must have scratchCapacity>=minCapacity. The returned buffer is only valid until the next write operation on the UnicodeString.

For details see Appendable::getAppendBuffer().

Parameters

  minCapacity | required minimum capacity of the returned buffer; must be non-negative
  desiredCapacityHint | desired capacity of the returned buffer; must be non-negative
  scratch | default caller-owned buffer
  scratchCapacity | capacity of the scratch buffer
  resultCapacity | pointer to an integer which will be set to the capacity of the returned buffer

Returns
  a buffer with *resultCapacity>=minCapacity

Stable:
  ICU 4.8

Reimplemented from icu::Appendable.

## ◆ reserveAppendCapacity()

virtual UBool icu::UnicodeStringAppendable::reserveAppendCapacity | ( | int32_t | appendCapacity | ) |
| overridevirtual

Tells the UnicodeString that the caller is going to append roughly appendCapacity char16_ts.

Parameters

  appendCapacity | estimated number of char16_ts that will be appended

Returns
  true if the operation succeeded

Stable:
  ICU 4.8

Reimplemented from icu::Appendable.

The documentation for this class was generated from the following file:

- common/unicode/appendable.h